module("luci.controller.qmodem_hc",package.seeall)
local t=require"luci.http"
local a=require"nixio.fs"
local e=require("luci.jsonc")
function index()
entry({"admin","modem","qmodem","modem_sim"},cbi("qmodem_hc/modem_sim"),luci.i18n.translate("SIM Config"),23).leaf=true
entry({"admin","modem","qmodem","set_sim"},call("setSIM"),nil).leaf=true
entry({"admin","modem","qmodem","get_sim"},call("getSIM"),nil).leaf=true
end
function getSimSlot(e)
local e=a.readfile(e)
local e=string.match(e,"%d")
if e=="0"then
return"SIM2"
else
return"SIM1"
end
end
function shell(e)
local e=io.popen(e)
local t=e:read("*a")
e:close()
return t
end
function getNextBootSlot()
local e="fw_printenv -n sim2"
local e=shell(e)
if e==""then
return"SIM1"
else
return"SIM2"
end
end
function writeJsonResponse(a,t)
local e={}
e["current_slot"]=a
e["nextboot_slot"]=t
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function getSIM()
local e="/sys/class/gpio/sim/value"
local e=getSimSlot(e)
local t=getNextBootSlot()
writeJsonResponse(e,t)
end
function setSIM()
local e="/sys/class/gpio/sim/value"
local a="/sys/class/gpio/4g/value"
local t=t.formvalue("slot")
local i=getSimSlot(e)
local o=1
if i==t then
o=0
end
if t=="SIM1"then
sysfs_cmd="echo 1 >"..e
fw_setenv_cmd="fw_setenv sim2"
elseif t=="SIM2"then
sysfs_cmd="echo 0 >"..e
fw_setenv_cmd="fw_setenv sim2 1"
end
shell(sysfs_cmd)
shell(fw_setenv_cmd)
if o==1 then
shell("echo 0 >"..a)
os.execute("sleep 1")
shell("echo 1 >"..a)
end
local e=getSimSlot(e)
local t=getNextBootSlot()
writeJsonResponse(e,t)
end
